---
before_script:
# Set Docker image tag to commit tag or `latest` if commit is not tagged
  - "if [[ \"$CI_COMMIT_REF_NAME\" == \"$CI_COMMIT_TAG\" ]]; then export DOCKER_TAG=\"$CI_COMMIT_TAG\"; else export DOCKER_TAG=\"latest\"; fi"
  - "export IMAGE_NAME=\"$CI_REGISTRY_IMAGE:$DOCKER_TAG\""

stages:
  - build
  - push
  - deploy

build:
  stage: build # Build Docker image
  script:
    - podman build -t $IMAGE_NAME .
  only:
    - main

push:
  stage: push # Push Docker image to GitLab repo registry
  script:
    - podman login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - podman push $IMAGE_NAME
    - echo $IMAGE_NAME

  only:
    - main

deploy:
  stage: deploy
  script:
    # Update the Helm
    - helm upgrade --install my-app ./helm_charts/myapp_chart --set image.repository=$IMAGE_NAME


# This pipeline will:

# 1. Build Docker image when a push to the `main` branch or a tag is made.
# 2. Push Docker image to GitLab Container Registry on the `push` stage.
# 3. Deploy application to Kubernetes using Helm on the `deploy` stage.
# 4. `deploy` stage updates or installs Helm release using the Docker image built and pushed on the previous stages.